import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import os.path
import textwrap
from random import choice, randint
import os
from shutil import copyfile

exercise = 'src.who_cheated'
function = "cheaters"

                
def format(f):
    return ", ".join(f)

def file_exists(f: str):
    try:
        open(f)
        return True
    except:
        return False

def get_missing(result: list, correct: list):
    return [x for x in correct if x not in result]

def get_extra(result: list, correct: list):
    return [x for x in result if x not in correct]

filename1 = "start_times.csv"
filename2 = "submissions.csv"


@points('1.who_cheated')
class WhoCheatedTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
            for filename in (filename1, filename2):
                data_file = os.path.join('src', filename)
                copyfile(data_file, filename)  
            cls.module = load_module(exercise, 'en')

    @classmethod
    def tearDownClass(cls):
         os.remove(filename1)
         os.remove(filename2)

    def test_0a_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test1_function_exists(self):
        try:
            from src.who_cheated import cheaters
        except:
            self.assertTrue(False, 'Din kod bör innehålla funktionen cheaters()')
 
    def test2_type_of_return_value(self):
        cheaters = load(exercise, function, 'en')
        try:
            result = cheaters()
        except:
            self.assertTrue(False, 'Ett fel inträffade under körningen av funktionen cheaters, se till att programmet fungerar')
        
        taip = str(type(result)).replace("<class '","").replace("'>","")
        self.assertTrue(type(result) == list, f"Funktion cheaters förväntas returnera en lista, nu returnerar den ett värde {result} vars typ är {taip}")

    def test3_list_content(self):
        correct = ['matti', 'antti', 'henrik', 'arto', 'esko', 'kjell', 'jyrki', 'teemu', 'tiina', 'virpi', 'liisa', 'kotivalo', 'justiina', 'luukas', 'johannes']
        cheaters = load(exercise, function, 'en')
        try:
            result = cheaters()
        except:
            self.assertTrue(False, 'Ett fel inträffade under körningen av funktionen cheaters, se till att programmet fungerar')
        
        self.assertTrue(len(result) == len(correct), f"Listan som returneras av funktionen förväntas innehålla {len(correct)} objekt, men nu innehåller den {len(result)} objekt: {result}")
        
        missing = get_missing(result, correct)
        extra = get_extra(result, correct)

        self.assertTrue(len(missing) == 0, f"Listan som returneras saknar följande namn: {format(missing)}. Nu var listan {result}")
        self.assertTrue(len(extra) == 0, f"Listan som returneras innehåller följande extra namn: {format(extra)}. Nu var listan {result}")
        self.assertEqual(sorted(correct), sorted(result), f"Innehållet i listan {result} stämmer inte överens med modelllösningen {correct}")
  
if __name__ == '__main__':
    unittest.main()